diff --git a/ir/Makefile b/ir/Makefile
index 74a3283..c7de7c9 100644
--- a/ir/Makefile
+++ b/ir/Makefile
@@ -57,17 +57,19 @@ SHARED_OBJS=$(STATIC_OBJS:.o=.pic.o)
 # mingw hack
 
 ifeq ($(OSTYPE), windows)
+ifneq ($(SUBOSTYPE), parity)
 ifeq ($(HAVE_SHARED), yes)
 HAVE_SHARED := no
 HAVE_STATIC := yes
 endif
 endif
+endif
 
 # normal rules
 
 all: lib prg
 
-prg: ird
+prg: ird$(EXEEXT)
 
 ifeq ($(HAVE_SHARED), yes)
 ifeq ($(HAVE_STATIC), yes)
@@ -79,8 +81,8 @@ else
 lib: .depend libmicoir$(VERSION).a
 endif
 
-ird: main.o ../idl/libidl.a ../orb/$(LIBMICO) $(LIBMICOIR)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) main.o -L. $(LDLIBS) ../idl/libidl.a -o ird
+ird$(EXEEXT): main.o ../idl/libidl.a ../orb/$(LIBMICO) $(LIBMICOIR)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) main.o -L. $(LDLIBS) ../idl/libidl.a -o $@
 	$(POSTLD) $@
 
 libmicoir$(VERSION).$(SOEXT): $(SHARED_OBJS)
@@ -96,6 +98,7 @@ endif
 	$(LDSO) -o libmicoir$(VERSION) $(SHARED_OBJS) -L../libs $(LDMICO) $(PLATFORM_LIBS)
 	$(IDIRCMD) ../libs
 	cd ../libs; $(RM) $@; $(LN) ../ir/$@ .
+	test ! -f $@.dll || ( cd ../libs; $(RM) $@.dll; $(LN) ../ir/$@.dll . )
 
 libmicoir$(VERSION).a: $(STATIC_OBJS)
 ifeq ($(HAVE_REPO), yes)
@@ -155,18 +158,19 @@ diffs:
 # cleaning
 
 clean:
-	-$(RM) libs libmicoir* ird
-	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid
+	-$(RM) libs libmicoir* ird$(EXEEXT)
+	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid *.dll *.pdb *.exp
 	-$(RM) .depend TAGS core nohup.out
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) ird $(INSTDIR)/bin
+	$(IBINCMD) ird$(EXEEXT) $(INSTDIR)/bin
 ifeq ($(HAVE_STATIC), yes)
 	$(ILIBCMD) libmicoir$(VERSION).a $(INSTDIR)/lib
 endif
 ifeq ($(HAVE_SHARED), yes)
 	$(ILIBCMD) libmicoir$(VERSION).$(SOEXT) $(INSTDIR)/lib
+	test ! -f libmicoir$(VERSION).$(SOEXT).dll || $(ILIBCMD) libmicoir$(VERSION).$(SOEXT).dll $(INSTDIR)/lib
 endif
 
 install-cd: install
diff --git a/orb/Makefile b/orb/Makefile
index 213fe0a..c961fe2 100644
--- a/orb/Makefile
+++ b/orb/Makefile
@@ -207,10 +207,23 @@ all: lib prg
 prg:
 
 ifeq ($(OSTYPE), windows)
+ifneq ($(SUBOSTYPE), parity)
 ifeq ($(HAVE_SHARED), yes)
 lib: .depend libmico$(VERSION).a mico$(NODOTVERSION).dll
 else
 lib: .depend libmico$(VERSION).a
+endif
+else
+ifeq ($(HAVE_SHARED), yes)
+ifeq ($(HAVE_STATIC), yes)
+lib: .depend libmico$(VERSION).$(SOEXT) libmico$(VERSION).a
+else
+lib: .depend libmico$(VERSION).$(SOEXT)
+endif
+else
+lib: .depend libmico$(VERSION).a
+endif
+
 endif
 
 else
@@ -252,6 +265,10 @@ endif
 	$(LDSO) -o libmico$(VERSION) $(SHARED_OBJS) $(PLATFORM_LIBS)
 	$(IDIRCMD) ../libs
 	cd ../libs; $(RM) $@; $(LN) ../orb/$@ .
+	if test -f $@.dll; then \
+		cd ../libs; $(RM) $@.dll; $(LN) ../orb/$@.dll .; \
+	fi
+
 endif
 
 # static
@@ -412,7 +429,7 @@ diffs:
 	$(RM) -r orig
 
 clean:
-	$(RM) *.rpo *.ii *.ti *.a *.o *~ *.$(SOEXT) *.exe .depend
+	$(RM) *.rpo *.ii *.ti *.a *.o *~ *.$(SOEXT) *.exe .depend *.dll *.pdb *.exp
 	(cd transport; $(RM) *.rpo *.ii *.ti *.a *.o *~ .depend)
 	(cd os-thread; $(RM) *.rpo *.ii *.ti *.a *.o *~ .depend)
 	(cd security; $(RM) *.rpo *.ii *.ti *.a *.o *~ .depend)
@@ -425,6 +442,7 @@ ifeq ($(HAVE_STATIC), yes)
 endif
 ifeq ($(HAVE_SHARED), yes)
 	$(ILIBCMD) libmico$(VERSION).$(SOEXT) $(INSTDIR)/lib
+	test ! -f libmico$(VERSION).$(SOEXT).dll || $(ILIBCMD) libmico$(VERSION).$(SOEXT).dll $(INSTDIR)/lib
 endif
 
 install-cd: install
diff --git a/orb/orb_all.cc b/orb/orb_all.cc
index 0cbe617..8b20bd3 100644
--- a/orb/orb_all.cc
+++ b/orb/orb_all.cc
@@ -26,7 +26,11 @@
 #include "codeset.cc"
 #include "queue.cc"
 #include "static.cc"
+#ifndef _WIN32
 #include "os-unix.cc"
+#else
+#include "os-windows.cc"
+#endif
 #include "ssl.cc"
 #include "current.cc"
 #include "valuetype.cc"
diff --git a/tools/iordump/Makefile b/tools/iordump/Makefile
index e7db669..03f772e 100644
--- a/tools/iordump/Makefile
+++ b/tools/iordump/Makefile
@@ -34,15 +34,15 @@ OBJS = ${SRCS:.cc=.o}
 
 # normal rules
 
-all: .depend iordump
+all: .depend iordump$(EXEEXT)
 
-iordump: $(OBJS) ../../orb/$(LIBMICO)
+iordump$(EXEEXT): $(OBJS) ../../orb/$(LIBMICO)
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) -L../../idl $(OBJS) -lidl $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) iordump $(INSTDIR)/bin
+	$(IBINCMD) iordump$(EXEEXT) $(INSTDIR)/bin
 
 # cleaning
 

